<?php
$parse_uri = explode( 'wp-content', $_SERVER['SCRIPT_FILENAME'] );
require_once( $parse_uri[0] . 'wp-load.php' );

$opauth_dir = cjfm_item_path('modules_dir').'/shortcodes/opauth/';
$opauth_url = cjfm_item_path('modules_url').'/shortcodes/opauth/';
$opauth_path = str_replace(site_url(), '', $opauth_url);

/**
 * Opauth configuration file template for advanced user
 * ====================================================
 * To use: rename to opauth.conf.php and tweak as you like
 * For quick and easy set up, refer to opauth.conf.php.default
 */

$config = array(

	'host' => site_url(),
/**
 * Path where Opauth is accessed.
 * 
 * Begins and ends with /
 * eg. if Opauth is reached via http://example.org/auth/, path is '/auth/'
 * if Opauth is reached via http://auth.example.org/, path is '/'
 */
	'path' => $opauth_path.'process/',

/**
 * Uncomment if you would like to view debug messages
 */
	//'debug' => true,
	
/**
 * Callback URL: redirected to after authentication, successful or otherwise
 */
	'callback_url' => site_url().$opauth_path.'process/callback.php',

/**
 * Callback transport, for sending of $auth response
 * 
 * 'session': Default. Works best unless callback_url is on a different domain than Opauth
 * 'post'   : Works cross-domain, but relies on availability of client-side JavaScript.
 * 'get'    : Works cross-domain, but may be limited or corrupted by browser URL length limit 
 *            (eg. IE8/IE9 has 2083-char limit)
 */
	//'callback_transport' => 'session',

/**
 * A random string used for signing of $auth response.
 */
	'security_salt' => sha1(md5(site_url().'opauth'.ABSPATH)),
	
/**
 * Higher value, better security, slower hashing;
 * Lower value, lower security, faster hashing.
 */
	//'security_iteration' => 300,	
	
/**
 * Time limit for valid $auth response, starting from $auth response generation to validation.
 */
	//'security_timeout' => '2 minutes',

/**
 * Directory where Opauth strategies reside
 */
	//'strategy_dir' => '{lib_dir}Strategy/',
		
/**
 * Strategy
 * Refer to individual strategy's documentation on configuration requirements.
 * 
 * eg.
 * 'Strategy' => array(
 * 
 *   'Facebook' => array(
 *      'app_id' => 'APP ID',
 *      'app_secret' => 'APP_SECRET'
 *    ),
 * 
 * )
 *
 */
	'Strategy' => array(
		// Define strategies and their respective configs here
		'Facebook' => array(
			'app_id' => cjfm_get_option('Facebook_appID'),
			'app_secret' => cjfm_get_option('Facebook_appSecret'),
			'scope' => 'email'
		),
		'Twitter' => array(
			'key' => cjfm_get_option('Twitter_appID'),
			'secret' => cjfm_get_option('Twitter_appSecret'),
		),
		'Google' => array(
			'client_id' => cjfm_get_option('Google_appID'),
			'client_secret' => cjfm_get_option('Google_appSecret'),
			'redirect_uri' => site_url().$opauth_path.'process/callback.php',
		),
		'LinkedIn' => array(
			'api_key' => cjfm_get_option('LinkedIn_appID'),
			'secret_key' => cjfm_get_option('LinkedIn_appSecret'),
		),
	),
);











